| Demo HCI Implementation for WiMOD-LR Devices V2.0.3

Public Member Functions | List of all members
WiMOD_SAP_RadioLink Class Reference

Implementation for the ServiceAccessPoint RadioLink (LR-Base firmware only) More...

`#include <SAP/WiMOD_SAP_RadioLink.h>`

Inheritance diagram for WiMOD_SAP_RadioLink:
[legend]

## Public Member Functions
| WiMOD_SAP_RadioLink (TWiMODLRHCI *hci, UINT8 *buffer, UINT16 bufferSize)
| Constructor. More...
virtual | ~WiMOD_SAP_RadioLink (void)
| Destructor. More...
virtual TWiMODLRResultCodes | SendUData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Tries to send transmit U-Data to peer module via RF link. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_Msg *radioLinkMsg)
| Convert a received low level HCI-Msg to a high-level RadioLink-Msg. More...
virtual TWiMODLRResultCodes | SendCData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Tries to send transmit C-Data to peer module via RF link. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_CdataInd *cDataTxInfo)
| Convert a received low level HCI-Msg to a high-level CDataTx Info. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_UdataInd *uDataTxInfo)
| Convert a received low level HCI-Msg to a high-level UDataTx Info. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_AckTxInd_Msg *txAckIndInfo)
| Convert a received low level HCI-Msg to a high-level AckTxInd Info. More...
virtual TWiMODLRResultCodes | SetAckData (const TWiMODLR_RadioLink_Msg *txMsg, UINT8 *statusRsp)
| Sets additional user payload for the next ack frame to send. More...
virtual bool | convert (TWiMODLR_HCIMessage &RxMsg, TWiMODLR_RadioLink_RawMsg *radioLinkRawMsg)
virtual void | RegisterUDataRxClient (TRadioLinkUDataRxIndicationCallback cb)
| Register a callback function for the RX U-Data Indication - optional -. More...
virtual void | RegisterUDataTxClient (TRadioLinkUDataTxIndicationCallback cb)
| Register a callback function for the TX U-Data Indication - optional -. More...
virtual void | RegisterRawDataRxClient (TRadioLinkRawDataRxIndicationCallback cb)
| Register a callback function for the RX Raw-Data Indication - optional -. More...
virtual void | RegisterCDataRxClient (TRadioLinkCDataRxIndicationCallback cb)
| Register a callback function for the RX C-Data Indication - optional -. More...
virtual void | RegisterCDataTxClient (TRadioLinkCDataTxIndicationCallback cb)
| Register a callback function for the TX C-Data Indication - optional -. More...
virtual void | RegisterAckRxClient (TRadioLinkAckRxIndicationCallback cb)
| Register a callback function for the RX Ack (+data) Indication - optional -. More...
virtual void | RegisterAckRxTimeoutClient (TRadioLinkAckRxTimeoutIndicationCallback cb)
| Register a callback function for the Ack Timeout Indication - optional -. More...
virtual void | RegisterAckTxCallback (TRadioLinkAckTxIndicationCallback cb)
| Register a callback function for the TX Ack Indication - optional -. More...
virtual void | DispatchRadioLinkMessage (TWiMODLR_HCIMessage &rxMsg)

## Detailed Description

Implementation for the ServiceAccessPoint RadioLink (LR-Base firmware only)

## Constructor & Destructor Documentation

## ◆ WiMOD_SAP_RadioLink()

WiMOD_SAP_RadioLink::WiMOD_SAP_RadioLink | ( | TWiMODLRHCI * | hci,
|  | UINT8 * | buffer,
|  | UINT16 | bufferSize
| ) |  |

Constructor.

Parameters

  hci | Pointer to HCI processor object
  buffer | pointer to storage area for building tx frames; MUST BE VALID
  bufferSize | size of the buffer

## ◆ ~WiMOD_SAP_RadioLink()

WiMOD_SAP_RadioLink::~WiMOD_SAP_RadioLink | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ convert() [1/4]

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_AckTxInd_Msg * | txAckIndInfo
| ) |  |
| virtual

Convert a received low level HCI-Msg to a high-level AckTxInd Info.

This function should be used by the AckTx Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  txAckIndInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented in WiMOD_SAP_RadioLink_ProLink.

## ◆ convert() [2/4]

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_CdataInd * | cDataTxInfo
| ) |  |
| virtual

Convert a received low level HCI-Msg to a high-level CDataTx Info.

This function should be used by the Tx-C-Data Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  cDataTxInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented in WiMOD_SAP_RadioLink_ProLink.

## ◆ convert() [3/4]

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_Msg * | radioLinkMsg
| ) |  |
| virtual

Convert a received low level HCI-Msg to a high-level RadioLink-Msg.

This function should be used by the RxUData / RxCData callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  radioLinkMsg | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented in WiMOD_SAP_RadioLink_ProLink.

## ◆ convert() [4/4]

bool WiMOD_SAP_RadioLink::convert | ( | TWiMODLR_HCIMessage & | RxMsg,
|  | TWiMODLR_RadioLink_UdataInd * | uDataTxInfo
| ) |  |
| virtual

Convert a received low level HCI-Msg to a high-level UDataTx Info.

This function should be used by the Tx-U-Data Indication Callback functions prior processing the received data message.

Parameters

  RxMsg | Reference to low-level HCI message.

Warning
  DO NOT MANIPULATE THESE VALUES !!!

Parameters

  uDataTxInfo | Pointer to the buffer where to store the received data

Return values

  true | if the conversion was successful

Reimplemented in WiMOD_SAP_RadioLink_ProLink.

## ◆ RegisterAckRxClient()

void WiMOD_SAP_RadioLink::RegisterAckRxClient | ( | TRadioLinkAckRxIndicationCallback | cb | ) |
| virtual

Register a callback function for the RX Ack (+data) Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkAckRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

## ◆ RegisterAckRxTimeoutClient()

void WiMOD_SAP_RadioLink::RegisterAckRxTimeoutClient | ( | TRadioLinkAckRxTimeoutIndicationCallback | cb | ) |
| virtual

Register a callback function for the Ack Timeout Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkAckRxTimeoutIndicationCallback for details

## ◆ RegisterAckTxCallback()

void WiMOD_SAP_RadioLink::RegisterAckTxCallback | ( | TRadioLinkAckTxIndicationCallback | cb | ) |
| virtual

Register a callback function for the TX Ack Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkAckTxIndicationCallback for details

## ◆ RegisterCDataRxClient()

void WiMOD_SAP_RadioLink::RegisterCDataRxClient | ( | TRadioLinkCDataRxIndicationCallback | cb | ) |
| virtual

Register a callback function for the RX C-Data Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkCDataRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

## ◆ RegisterCDataTxClient()

void WiMOD_SAP_RadioLink::RegisterCDataTxClient | ( | TRadioLinkCDataTxIndicationCallback | cb | ) |
| virtual

Register a callback function for the TX C-Data Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkCDataTxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

## ◆ RegisterRawDataRxClient()

void WiMOD_SAP_RadioLink::RegisterRawDataRxClient | ( | TRadioLinkRawDataRxIndicationCallback | cb | ) |
| virtual

Register a callback function for the RX Raw-Data Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkRawDataRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

## ◆ RegisterUDataRxClient()

void WiMOD_SAP_RadioLink::RegisterUDataRxClient | ( | TRadioLinkUDataRxIndicationCallback | cb | ) |
| virtual

Register a callback function for the RX U-Data Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkUDataRxIndicationCallback for details

Note
  : the callback function should call the corresponding convert in order to decode the message properly

## ◆ RegisterUDataTxClient()

void WiMOD_SAP_RadioLink::RegisterUDataTxClient | ( | TRadioLinkUDataTxIndicationCallback | cb | ) |
| virtual

Register a callback function for the TX U-Data Indication - optional -.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  cb | Pointer a callback function

See also
  TRadioLinkUDataTxIndicationCallback for details

## ◆ SendCData()

TWiMODLRResultCodes WiMOD_SAP_RadioLink::SendCData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

Tries to send transmit C-Data to peer module via RF link.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  txMsg | Data structure containing the TX-data and options.

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

Reimplemented in WiMOD_SAP_RadioLink_ProLink.

## ◆ SendUData()

TWiMODLRResultCodes WiMOD_SAP_RadioLink::SendUData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

Tries to send transmit U-Data to peer module via RF link.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  txMsg | Data structure containing the TX-data and options.

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

## ◆ SetAckData()

TWiMODLRResultCodes WiMOD_SAP_RadioLink::SetAckData | ( | const TWiMODLR_RadioLink_Msg * | txMsg,
|  | UINT8 * | statusRsp
| ) |  |
| virtual

Sets additional user payload for the next ack frame to send.

See also
  TWiMODLRResultCodes for interpretation of the values

Parameters

  txMsg | Pointer to data structure containing the payload data. note: Max ack payload size is 8 byte!

See also
  TWiMODLR_RadioLink_Msg for details

Parameters

  statusRsp | Status byte contained in the local response of the module

Return values

  WiMODLR_RESULT_OK | if command transmit to WiMOD was ok

Reimplemented in WiMOD_SAP_RadioLink_ProLink.

The documentation for this class was generated from the following files:

- SAP/WiMOD_SAP_RadioLink.h
- SAP/WiMOD_SAP_RadioLink.cpp